<?php

 /**
 * This is the whos online helper file
 *
 * PHP version 5
 *
 * @category   JFusion
 * @package    Modules
 * @subpackage Whosonline
 * @author     JFusion Team <webmaster@jfusion.org>
 * @copyright  2008 JFusion. All rights reserved.
 * @license    http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @link       http://www.jfusion.org
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

/**
 * Helper class
 *
 * @category   JFusion
 * @package    Modules
 * @subpackage Whosonline
 * @author     JFusion Team <webmaster@jfusion.org>
 * @copyright  2008 JFusion. All rights reserved.
 * @license    http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @link       http://www.jfusion.org
 */
class modjfusionWhosOnlineHelper
{

    /**
     * render a plugin
     *
     * @param string $jname  name of element
     * @param string $config value of element
     * @param string $params node of element
     *
     * @return string html
     */
    function renderPluginAuto($jname, $config, $params)
    {
        //now check to see if the plugin is configured
        $jdb = & JFactory::getDBO();
        $query = 'SELECT status from #__jfusion WHERE name = ' . $jdb->Quote($jname);
        $jdb->setQuery($query);
        if ($jdb->loadResult() == 1) {
            //get the itemid and jname to get any missing urls
            $link_itemid = $config['itemid'];
            if (is_numeric($link_itemid)) {
                $menu = & JSite::getMenu();
                $menu_param = & $menu->getParams($link_itemid);
                $plugin_param = unserialize(base64_decode($menu_param->get('JFusionPluginParam')));
                $link_jname = $plugin_param['jfusionplugin'];
            } else {
                $link_jname = $jname;
            }
            if (JFusionFunction::validPlugin($link_jname)) {
                $forum = & JFusionFactory::getForum($link_jname);
                $public = & JFusionFactory::getPublic($jname);
                $db = & JFusionFactory::getDatabase($jname);
                if (JError::isError($db)) {
                    return JText::_('NO_DATABASE');
                } else {
                    $output = '';
                    //show the number of people online if set to do so
                    if ($config["showmode"] != "1") {
                        $numGuests = $public->getNumberOnlineGuests();
                        $numMembers = $public->getNumberOnlineMembers();
                        $output.= JText::_('WE_HAVE') . '&nbsp;';
                        if ($numGuests == 1) {
                            $output.= JText::sprintf('GUEST', '1');
                        } elseif ($numGuests == 0 || $numGuests > 1) {
                            $output.= JText::sprintf('GUESTS', $numGuests);
                        }
                        $output.= '&nbsp;' . JText::_('AND') . '&nbsp;';
                        if ($numMembers == 1) {
                            $output.= JText::sprintf('MEMBER', '1');
                        } elseif ($numMembers == 0 || $numMembers > 1) {
                            $output.= JText::sprintf('MEMBERS', $numMembers);
                        }
                        $output.= '&nbsp;' . JText::_('ONLINE') . '<br />';
                    }
                    $query = $public->getOnlineUserQuery($config["member_limit"]);
                    $db->setQuery($query);
                    $results = $db->loadObjectList();
                    if (JError::isError($db)) {
                        return $db->stderr();
                    } elseif (empty($results) && $config['showmode'] == "1") {
                        $output.= JText::_('NO_USERS_ONLINE');
                    } elseif (!empty($config["showmode"]) && (count($results) > 0)) {
                        $output.= "<ul>";
                        // process result
                        foreach ($results as $result) {
                            //assign the joomla_userid and jfusion_userid variables
                            if ($link_jname == $jname) {
                                $jfusion_userid = $result->userid;
                                if ($jname == 'joomla_int') {
                                    //Joomla's userid is readily available
                                    $joomla_userid = $result->userid;
                                } elseif (!empty($userlookup)) {
                                    //obtain the correct Joomla userid for the user
                                    $lookupUsername = (!empty($result->username_clean)) ? $result->username_clean : $result->username;
                                    //find it in the lookup table
                                    $userlookup = JFusionFunction::lookupUser($link_jname, $result->userid, false, $lookupUsername);
                                    if (!empty($userlookup)) {
                                        $joomla_userid = $userlookup->id;
                                    }
                                }
                            } else {
                                //first, the userid of the JFusion plugin for the menu item must be obtained
                                $JFusionUser = & JFusionFactory::getUser($link_jname);
                                $userinfo = $JFusionUser->getUser($result);
                                if (!empty($userinfo)) {
                                    $jfusion_userid = $userinfo->userid;
                                    if ($jname == "joomla_int") {
                                        //Joomla's userid is readily available
                                        $joomla_userid = $result->userid;
                                    } else {
                                        $userlookup = JFusionFunction::lookupUser($link_jname, $userinfo->userid, false, $userinfo->username);
                                        if (!empty($userlookup)) {
                                            $joomla_id = $userlookup->id;
                                        }
                                    }
                                }
                            }
                            $name = ($config["name"] == 1) ? $result->name : $result->username;
                            if ($config['userlink']) {
                                if ($config['userlink_software'] != '' && $config['userlink_software'] != 'jfusion' && $config["userlink_software"] != 'custom' && !empty($joomla_userid)) {
                                    $user_url = JFusionFunction::getAltProfileURL($config['userlink_software'], $joomla_userid);
                                } elseif ($config['userlink_software'] == 'custom' && !empty($config['userlink_custom']) && !empty($joomla_userid)) {
                                    $user_url = $config['userlink_custom'] . $joomla_userid;
                                } else {
                                    $user_url = false;
                                }
                                if ($user_url === false && $link_jname != 'joomla_int' && $link_jname != 'joomla_ext') {
                                    $user_url = JFusionFunction::routeURL($forum->getProfileURL($jfusion_userid, $result->username), $config['itemid']);
                                }
                                $user = '<a href="' . $user_url . '">' . $name . '</a>';
                            } else {
                                $user = $name;
                            }
                            $avatar = '';
                            if ($config['avatar']) {
                                // retrieve avatar
                                $avatarSrc = $config['avatar_software'];
                                if ($link_jname != 'joomla_int' && $link_jname != 'joomla_ext' && ($avatarSrc == '' || $avatarSrc == 'jfusion') && !empty($jfusion_userid)) {
                                    $avatarImg = $forum->getAvatar($jfusion_userid);
                                } elseif (!empty($avatarSrc) && $avatarSrc != 'jfusion' && !empty($joomla_userid)) {
                                    $avatarImg = JFusionFunction::getAltAvatar($avatarSrc, $joomla_userid);
                                }
                                if (empty($avatarImg)) {
                                    $avatarImg = JFusionFunction::getJoomlaURL() . 'components/com_jfusion/images/noavatar.png';
                                }
                                $maxheight = & $config['avatar_height'];
                                $maxwidth = & $config['avatar_width'];
                                $avatar = "<img style='vertical-align:middle; margin:3px; ";
                                $avatar.= (!empty($maxheight)) ? " max-height: {$maxheight}px;" : "";
                                $avatar.= (!empty($maxwidth)) ? " max-width: {$maxwidth}px;" : "";
                                $avatar.= "' src='$avatarImg' alt='avatar' />";
                            }
                            //put it all together for output
                            $output.= '<li>' . $avatar . ' <b>' . $user . '</b></li>';
                        }
                        $output.= "</ul>";
                    }
                    return $output;
                }
            } else {
                return JText::_('NO_MENU_ITEM');
            }
        } else {
            return JText::_('NOT_CONFIGURED');
        }
    }

    /**
     * render a plugin mode
     *
     * @param string $jname       name of element
     * @param string $config      value of element
     * @param string $view        value of element
     * @param string $pluginParam node of element
     *
     * @return string html
     */
    function renderPluginMode($jname, $config, $view, $pluginParam)
    {
        $public = & JFusionFactory::getPublic($jname);
        if (method_exists($public, "renderWhosOnlineModule")) {
            return $public->renderWhosOnlineModule($config, $view, $pluginParam);
        }
        return JText::_('NOT_IMPLEMENTED_YET');
    }
}